//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using Hiperscan.ApoIdentCommon.ApoConfig.IO;

namespace Hiperscan.ApoIdentCommon.ApoConfig.Cache
{
    public class GracePeriod : CacheManagement<GracePeriod, GracePeriodEntry>
    {
        public GracePeriod()
        {
            this.Entries = new EntryWriter<GracePeriod>();
            this.Reset();
        }

        protected override GracePeriodEntry CloneCurrentValue()
        {
            GracePeriodEntry tmp = new GracePeriodEntry();
            tmp.QuantityUnit = this.CurrentValue.QuantityUnit;
            tmp.QuantityValue = this.CurrentValue.QuantityValue;

            return tmp;
        }

        protected override GracePeriodEntry ConvertFromString(string value)
        {
            return new GracePeriodEntry(value);
        }

        protected override string ConvertToString(GracePeriodEntry value)
        {
            return value.ToString();
        }

        protected override GracePeriodEntry GetDefaultValue()
        {
            return new GracePeriodEntry();
        }

        protected override bool StateChanged()
        {
                return this.CurrentValue.QuantityUnit != this.InitialValue.QuantityUnit ||
                       this.CurrentValue.QuantityValue != this.InitialValue.QuantityValue;
        }
    }
}
